#if !defined(AFX_CLIENT_H__E2CFA03B_14E0_46B4_9E6C_09C415A4AF78__INCLUDED_)
#define AFX_CLIENT_H__E2CFA03B_14E0_46B4_9E6C_09C415A4AF78__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Client.h : wb_[ t@C
//
enum {
	MMSO_STATUS,
	MMSO_CLOSE,
};

class CWLClientApp;

/////////////////////////////////////////////////////////////////////////////
// CTcpFifo class
//---------------------------------------------------------------------------
#define TCPFIFOMAX  128
#pragma pack(push, 1)
typedef struct {        // {ʐM\
	BYTE    ID[2];
	BYTE    Type;
	BYTE    SUBID;
	int     len;
	BYTE    *pData;
}TCPD;
typedef struct {        // {ʐM\
	BYTE    ID[2];
	BYTE    Type;
	BYTE    SUBID;
	int     len;
}TCPH;

typedef struct {
	LONG	sampfreq;
    LONG	size;
}CMD_OPEN;
typedef struct {
	LONG	Max;
	LONG	Remaining;
    LONG	Counter;
}RET_COUNTER;
#pragma pack(pop)

enum {
	cmdInOpen,
    cmdInClose,
    cmdOutOpen,
    cmdOutAbort,
    cmdOutFlush,
    cmdOutWrite,
    cmdSetOutCounter,
    cmdPTT,
};
enum {
	retRead,
	retCounter,
};
///---------------------------------------------------------
///  oCiehen
class CTcpFifo
{
private:
	TCPD    Slot[TCPFIFOMAX];
	TCPD    *tp;
	BYTE    *wp;
	int     WL;
	int     RL;
	int     Len;
	int     Mode;
	int     Line;
    int		Err;
public:
	CTcpFifo(void);
	~CTcpFifo(void);
	inline int __fastcall GetErr(void){return Err;};
	void __fastcall Reset(void);
	void __fastcall WriteByte(BYTE c);
	void __fastcall WriteString(LPCSTR sp);
	void __fastcall Write(const BYTE *sp, int n);
	inline int __fastcall GetLine(void){return Line;};
	TCPD* __fastcall GetData();
	void __fastcall DeleteData(TCPD *tp);
};
void __fastcall MakeTCPH(TCPH *tp, int Type, int n);
//
//---------------------------------------------------------------------------
#define	BFIFOMAX	64
class CFifo
{
private:
	int		m_rc;
	int		m_wc;
	int		m_cc;
	int		m_len;
	SHORT	*m_bf[BFIFOMAX];
	int		m_Flag;
public:
	CFifo(void);
	~CFifo(void);
	void __fastcall Clear(void);
	void __fastcall PutData(const SHORT *p, int len);
	void __fastcall GetData(SHORT *wp);
	SHORT *__fastcall GetRP(void);
	void __fastcall IncRP(void);
	SHORT *__fastcall GetWP(void);
	inline int __fastcall GetCount(void){return m_cc;};
    inline int __fastcall GetSize(void){return m_len;};
	void __fastcall UpdateSize(int len);
    BOOL __fastcall GetCritical(void);
};

/////////////////////////////////////////////////////////////////////////////
// CClient R}h ^[Qbg

class CClient : public CSocket
{
	DECLARE_DYNAMIC(CClient);

private:
	CWLClientApp	*m_pApp;
	BOOL			m_EnabledEvent;
// Agr[g
public:
// Iy[V
public:
	CClient(CWLClientApp *pApp);
	inline void EnableEvent(BOOL enabled){m_EnabledEvent = enabled;};

// I[o[Ch
public:
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CClient)
	public:
	virtual void OnReceive(int nErrorCode);
	virtual void OnClose(int nErrorCode);
	//}}AFX_VIRTUAL

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CClient)
		//  - ClassWizard ͂̈ʒuɃo֐ǉ܂͍폜܂B
	//}}AFX_MSG

// Cve[V
protected:
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_CLIENT_H__E2CFA03B_14E0_46B4_9E6C_09C415A4AF78__INCLUDED_)
