#include "stdafx.h"
#include "WLClient.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWLClientApp

BEGIN_MESSAGE_MAP(CWLClientApp, CWinApp)
	//{{AFX_MSG_MAP(CWLClientApp)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
		//        ̈ʒuɐR[hҏWȂłB
	//}}AFX_MSG_MAP
    ON_MESSAGE(WM_SOCKETEVENT, OnSocketEvent)
	ON_MESSAGE(WM_WAVE, OnWaveEvent)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWLClientApp ̍\z
//---------------------------------------------------------------------------
CWLClientApp::CWLClientApp()
{
	m_pSocket = NULL;
	m_pDialog = NULL;
	m_TcpRetryTime = 0;
	m_ServerName = "";
	m_PortTCP = 10203;
	m_swptt = m_mmptt = FALSE;
	m_swTimer = 0;
	m_Wave.m_pApp = (CWinApp *)this;
}
/////////////////////////////////////////////////////////////////////////////
CWLClientApp theApp;

/////////////////////////////////////////////////////////////////////////////
BOOL CWLClientApp::InitInstance()
{
	if( !AfxSocketInit() ){
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}
	m_clBack = GetSysColor(COLOR_BTNFACE);
	SetDialogBkColor(m_clBack);

	m_pDialog = new CWLDialog(NULL, this);
	ASSERT(m_pDialog);
	if( !m_pDialog ) return FALSE;

	char IniName[MAX_PATH];
	::GetModuleFileName(m_hInstance, IniName, sizeof(IniName));
	SetEXT(IniName, "ini");
	if( m_pszProfileName ) free(LPVOID(m_pszProfileName));
	m_pszProfileName = _tcsdup(IniName);

	m_PortTCP = GetProfileInt("N.TCP", "Port", m_PortTCP);
	m_ServerName = GetProfileString("N.TCP", "Server", m_ServerName);
	m_pDialog->m_ServerName = m_ServerName;
	m_pDialog->m_AutoConnect = GetProfileInt("N.TCP", "AutoConnect", FALSE);

	m_pDialog->m_Monitor = GetProfileInt("Sound", "Monitor", FALSE);
	m_Wave.m_InFifoSize = GetProfileInt("Sound", "RxFIFO", 12);
	m_Wave.m_OutFifoSize = GetProfileInt("Sound", "TxFIFO", 8);
	m_Wave.m_SoundStereo = GetProfileInt("Sound", "Channel", 0);

	m_pDialog->Create(IDD_DIALOG, NULL);

	RECT rc;
	rc.left = GetProfileInt("N.Window", "Left", 100);
	rc.top = GetProfileInt("N.Window", "Top", 50);
	int iconic = GetProfileInt("N.Window", "Minimized", FALSE);
	m_pDialog->WindowControl(&rc, iconic ? SW_MINIMIZE : SW_SHOW);

	DispStatus();
	return TRUE;
}
//---------------------------------------------------------------------------
int CWLClientApp::ExitInstance() 
{
	m_Wave.m_pApp = NULL;
	m_Wave.OutAbort();
	m_Wave.InClose();

	if( m_pDialog ){
		WriteProfileInt("N.TCP", "Port", m_PortTCP);
		WriteProfileString("N.TCP", "Server", m_ServerName);
		WriteProfileInt("N.TCP", "AutoConnect", m_pDialog->m_AutoConnect);
		WriteProfileInt("Sound", "Monitor", m_pDialog->m_Monitor);
		WriteProfileInt("Sound", "RxFIFO", m_Wave.m_InFifoSize);
		WriteProfileInt("Sound", "TxFIFO", m_Wave.m_OutFifoSize);
		WriteProfileInt("Sound", "Channel", m_Wave.m_SoundStereo);

		BOOL iconic = m_pDialog->IsIconic();
		WriteProfileInt("N.Window", "Minimized", iconic);
		if( !iconic ){
			RECT rc;
			m_pDialog->GetWindowRect(&rc);
			WriteProfileInt("N.Window", "Left", rc.left);
			WriteProfileInt("N.Window", "Top", rc.top);
		}
		m_pDialog->DestroyWindow();
		delete m_pDialog;
		m_pDialog = NULL;
	}
	DeleteSocket();
	return CWinApp::ExitInstance();
}
//---------------------------------------------------------------------------
void CWLClientApp::SetEXT(LPSTR s, LPCSTR pKey)
{
	int len = strlen(s);
	if( !len ) return;
	LPSTR t = s + len - 1;
	for( ; t > s; t-- ){
		if( *t == '.' ){
			t++;
			strcpy(t, pKey);
			return;
		}
	}
	t = s + len - 1;
	*t++ = '.';
	strcpy(t, pKey);
}
//---------------------------------------------------------------------------
BOOL CWLClientApp::CreateSocket(LPCSTR pName, UINT port)
{
	DeleteSocket();

	m_InFifo.Clear();
	m_pSocket = new CClient(this);
	ASSERT(m_pSocket);
	if( !m_pSocket ) return FALSE;

	if( !m_pSocket->Create() || !m_pSocket->Connect(pName, port) ){
		delete m_pSocket;
		m_pSocket = NULL;
	}
#if 0
	if( m_pSocket ){
		int txsize, rxsize, nodelay;
		int len = sizeof(int);
		m_pSocket->GetSockOpt(SO_RCVBUF, &rxsize, &len);
		m_pSocket->GetSockOpt(SO_SNDBUF, &txsize, &len);
		m_pSocket->GetSockOpt(TCP_NODELAY, &nodelay, &len, IPPROTO_TCP);
		char bf[128];
		wsprintf(bf, "TX:%u, RX:%u, ND:%u", txsize, rxsize, nodelay);
		m_pDialog->SetWindowText(bf);
	}
#endif
	return m_pSocket != NULL;
}
//---------------------------------------------------------------------------
void CWLClientApp::DeleteSocket(void)
{
	m_InFifo.Clear();
	if( m_pSocket ){
		m_pSocket->EnableEvent(FALSE);
		delete m_pSocket;
		m_pSocket = NULL;
	}
	m_TcpRetryTime = 30000/WTIMERINTERVAL;
}
//---------------------------------------------------------------------------
BOOL CWLClientApp::SendBuf(LPVOID p, int n)
{
	if( !IsConnected() ) return FALSE;

	DWORD dwTimeOut = ::GetTickCount() + STIMEOUT;
	int len;
	do {
		len = m_pSocket->Send(p, n);
		if( len == n ){
			return TRUE;
		}
		else if( len == SOCKET_ERROR ){
			break;
		}
		else if( len < n ){
			n -= len;
			p = LPBYTE(p)+len;
		}
		::Sleep(10);
        ProcessMessages();
		if( !IsConnected() ) break;
	} while( dwTimeOut > ::GetTickCount() );
	DeleteSocket();
	m_TcpRetryTime = 0;
	DispStatus();
	return FALSE;
}
//---------------------------------------------------------------------------
BOOL CWLClientApp::SendServer(int cmd, LPVOID p, UINT len)
{
	if( !IsConnected() ) return FALSE;

	BYTE *pb = new BYTE[sizeof(TCPH) + len];
	MakeTCPH((TCPH *)pb, cmd, len);
	if( len ) memcpy(pb + sizeof(TCPH), p, len);
	int r = SendBuf(pb, sizeof(TCPH)+len);
	delete pb;
	return r;
}
//---------------------------------------------------------------------------
void CWLClientApp::ProcessMessages(void)
{
	LONG lIdle = 0;
    MSG msg;
    while ( ::PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) ){ 
        PumpMessage();
		lIdle = TRUE;
    } 
	if( lIdle ){
		lIdle = 0;
		while( OnIdle(lIdle++ ) );
	}
}
//---------------------------------------------------------------------------
void CWLClientApp::OnTimer(void)
{
	if( !IsConnected() && m_pDialog->IsAutoConnect() ){
		m_pDialog->GetServerName(m_ServerName);
		if( !m_ServerName.IsEmpty() ){
			if( m_TcpRetryTime ){
				m_TcpRetryTime--;
				DispStatus();
			}
			else {
				ReqConnect();
			}
		}
	}
	if( m_swTimer ){
		m_swTimer--;
		if( !m_swTimer && m_swptt ){
			SetSwPTT(FALSE);
			::MessageBeep(MB_ICONEXCLAMATION);
		}
	}
}
//---------------------------------------------------------------------------
void CWLClientApp::ReqConnect(void)
{
	m_pDialog->GetServerName(m_ServerName);
	if( !m_ServerName.IsEmpty() ){
		m_TcpRetryTime = -1;
		DispStatus();
		m_TcpFifo.Reset();
		CreateSocket(m_ServerName, m_PortTCP);
		m_TcpRetryTime = 30000/WTIMERINTERVAL;
		DispStatus();
	}
}
//---------------------------------------------------------------------------
void CWLClientApp::ReqDisconnect(void)
{
	if( IsConnected() ){
		DeleteSocket();
	}
	m_pDialog->GetServerName(m_ServerName);
	DispStatus();
}
//---------------------------------------------------------------------------
void CWLClientApp::DispStatus(void)
{
	char bf[256];

	COLORREF col = RGB(0, 255, 0);
	BOOL fBConnect = !m_ServerName.IsEmpty();
	if( IsConnected() ){
		CString address;
		UINT	port;
		m_pSocket->GetSockName(address, port);
		wsprintf(bf, "TCP : Connected to %s", address);
		fBConnect = FALSE;
	}
	else {
		if( m_pDialog->IsAutoConnect() && !m_ServerName.IsEmpty() ){
			if( m_TcpRetryTime > 0 ){
				wsprintf(bf, "### Discconected  (%u)", m_TcpRetryTime * WTIMERINTERVAL / 1000);
			}
			else {
				strcpy(bf, "TCP : Trying...");
				fBConnect = FALSE;
			}
			col = RGB(255, 255, 0);
		}
		else {
			strcpy(bf, "### Disconnected");
			col = RGB(255, 0, 0);
		}
	}
	m_pDialog->UpdateButton(fBConnect);
	m_pDialog->UpdateStatus(bf, col);
}
//---------------------------------------------------------------------------
LRESULT CWLClientApp::OnSocketEvent(WPARAM wParam, LPARAM lParam)
{
	switch(wParam){
		case MMSO_STATUS:
			DispStatus();
			break;
		case MMSO_CLOSE:
			ASSERT(((CClient *)lParam) == m_pSocket);
			DeleteSocket();
			m_TcpRetryTime = 0;
			DispStatus();
			break;
    }
	return TRUE;
}
//---------------------------------------------------------------------------
LRESULT CWLClientApp::OnWaveEvent(WPARAM wParam, LPARAM lParam)
{
	SHORT buf[8192];

	switch(wParam){
		case MMWV_IN:
			while( m_Wave.m_InBC && m_Wave.IsInOpen() ){
				if( !m_Wave.InRead(buf) ){
					m_Wave.InClose();
					m_Wave.InOpen(&m_WFX, -1, m_InOpen.size);
				}
				else if( !m_mmptt ){
					m_InFifo.PutData(buf, m_InOpen.size);
					if( !IsOutFull() ){
						SendServer(cmdOutWrite, buf, m_InOpen.size*sizeof(SHORT));
				        m_Counter.Remaining++;
					}
				}
			}
			break;
		case MMWV_OUT:
			if( m_Wave.m_OutBC <= 1 ){			// timing adjustment
				memset(buf, 0, sizeof(buf));
				m_Wave.OutWrite(buf);
			}
			break;
    }
	return TRUE;
}
//---------------------------------------------------------------------------
void CWLClientApp::OnReceive(int nErrorCode) 
{
	if( !IsConnected() ) return;
	if( nErrorCode == SOCKET_ERROR ) return;
	
	BYTE    bf[8192];
	UINT    n;
	TCPD	*tp;

	n = m_pSocket->Receive(bf, sizeof(bf));
	if( n != SOCKET_ERROR ){
		m_TcpFifo.Write(bf, n);
		while( (tp = m_TcpFifo.GetData())!=NULL ){
			switch(tp->Type){
				case retRead:
					m_InFifo.PutData((SHORT *)tp->pData, tp->len / 2);
					if( m_pDialog->m_Monitor && m_Wave.IsOutOpen() && !m_Wave.IsOutBufFull() ){
						if( !m_Wave.OutWrite((SHORT *)tp->pData) ){
							m_Wave.OutAbort();
							OpenMonitor();
						}
					}
					break;
				case retCounter:
					memcpy(&m_Counter, tp->pData, sizeof(m_Counter));
                	break;
			}
			m_TcpFifo.DeleteData(tp);
		}
	}
}
//---------------------------------------------------------------------------
void CWLClientApp::InitWFX(const CMD_OPEN *pOpen)
{
	m_WFX.wFormatTag = WAVE_FORMAT_PCM;
	m_WFX.nChannels = 1;
	m_WFX.wBitsPerSample = 16;
	m_WFX.nSamplesPerSec = pOpen->sampfreq;
	m_WFX.nBlockAlign = WORD(m_WFX.nChannels *(m_WFX.wBitsPerSample/8));
	m_WFX.nAvgBytesPerSec = m_WFX.nBlockAlign * m_WFX.nSamplesPerSec;
	m_WFX.cbSize = 0;
}
//---------------------------------------------------------------------------
void CWLClientApp::OpenMonitor(void)
{
	if( m_pDialog->m_Monitor ){
		if( m_Wave.IsOutOpen() ) return;

		m_Wave.OutAbort();
		InitWFX(&m_InOpen);
		m_Wave.OutOpen(&m_WFX, -1, m_InOpen.size);
		SHORT buf[8192];
		memset(buf, 0, sizeof(buf));
		while(m_Wave.IsOutOpen() && m_Wave.IsOutBufCritical()){
			m_Wave.OutWrite(buf);
		}
	}
	else {
		if( !m_Wave.IsOutOpen() ) return;
		m_Wave.OutAbort();
	}
}
//---------------------------------------------------------------------------
void CWLClientApp::CloseSwPTT(void)
{
	if( m_swptt ){
		m_Wave.InClose();
		OutAbort();
		if( m_InFifo.GetSize() ) InOpen(m_InOpen.sampfreq, m_InOpen.size);
		m_swptt = FALSE;
		m_swTimer = 0;
	}
}
//---------------------------------------------------------------------------
void CWLClientApp::SetSwPTT(LONG tx)
{
	if( !IsConnected() ){
		m_pDialog->m_DlgPTT.SetState(FALSE);
		return;
	}
	else if( m_mmptt ){
		m_pDialog->m_DlgPTT.SetState(TRUE);
		return;
	}

	m_swptt = tx;
	tx = m_mmptt || m_swptt;
	SendServer(cmdPTT, &tx, sizeof(tx));
	m_pDialog->m_DlgPTT.SetState(tx);
	if( m_swptt ){
		SendServer(cmdInClose, NULL, 0);
		m_OutOpen.sampfreq = m_InOpen.sampfreq;
		m_OutOpen.size = m_InOpen.size;
		m_Counter.Max = 4;
		m_Counter.Remaining = 0;
		m_Counter.Counter = 0;
		SendServer(cmdOutOpen, &m_OutOpen, sizeof(m_OutOpen));
		m_Wave.OutAbort();
		InitWFX(&m_InOpen);
		m_Wave.InOpen(&m_WFX, -1, m_InOpen.size);
		m_swTimer = 300/3;
	}
	else {
		m_Wave.InClose();
		OutAbort();
		InOpen(m_InOpen.sampfreq, m_InOpen.size);
		m_swTimer = 0;
	}
}
//---------------------------------------------------------------------------
void CWLClientApp::SetPTT(LONG tx)
{
	if( !IsConnected() ) return;

	CloseSwPTT();
	m_mmptt = tx;
	SendServer(cmdPTT, &tx, sizeof(tx));
	m_pDialog->m_DlgPTT.SetState(tx);
	if( m_mmptt ){
		m_pDialog->m_DlgPTT.EnableWindow(FALSE);
		m_Wave.InClose();
		m_Wave.OutAbort();
	}
	else {
		OpenMonitor();
		m_pDialog->m_DlgPTT.EnableWindow(TRUE);
	}
}
//---------------------------------------------------------------------------
BOOL CWLClientApp::InOpen(DWORD sampfreq, LONG size)
{
	if( !IsConnected() ) return FALSE;

	m_InOpen.sampfreq = sampfreq;
    m_InOpen.size = size;
	m_InFifo.Clear();
    m_InFifo.UpdateSize(size);
	OpenMonitor();
	return SendServer(cmdInOpen, &m_InOpen, sizeof(m_InOpen));
}
//---------------------------------------------------------------------------
void CWLClientApp::InClose(void)
{
    m_InFifo.Clear();
	SendServer(cmdInClose, NULL, 0);
	m_Wave.OutAbort();
}
//---------------------------------------------------------------------------
BOOL CWLClientApp::InRead(SHORT *buf)
{
	if( !m_InFifo.GetSize() ) return FALSE;
	if( !IsConnected() ) return FALSE;

	for( int i = 0; i < (RTIMEOUT/10); i++ ){
		if( m_InFifo.GetCount() ){
			m_InFifo.GetData(buf);
			return TRUE;
        }
		::Sleep(10);
		ProcessMessages();
		if( !IsConnected() ) return FALSE;
    }
	return FALSE;
}
//---------------------------------------------------------------------------
LONG CWLClientApp::GetInExist(void)
{
	return m_InFifo.GetCount();
}
//---------------------------------------------------------------------------
BOOL CWLClientApp::IsInCritical(void)
{
	return m_InFifo.GetCritical();
}
//---------------------------------------------------------------------------
BOOL CWLClientApp::OutOpen(DWORD sampfreq, DWORD size)
{
	if( !IsConnected() ) return FALSE;

	CloseSwPTT();
	m_OutOpen.sampfreq = sampfreq;
    m_OutOpen.size = size;
	m_Counter.Max = 4;
	m_Counter.Remaining = 0;
    m_Counter.Counter = 0;
	return SendServer(cmdOutOpen, &m_OutOpen, sizeof(m_OutOpen));
}
//---------------------------------------------------------------------------
void CWLClientApp::OutAbort(void)
{
    m_OutOpen.size = 0;
	m_Counter.Remaining = 0;
    m_Counter.Counter = 0;
	if( !IsConnected() ) return;

	SendServer(cmdOutAbort, NULL, 0);
}
//---------------------------------------------------------------------------
void CWLClientApp::OutFlush(void)
{
	if( !IsConnected() ) return;

	SendServer(cmdOutFlush, NULL, 0);
}
//---------------------------------------------------------------------------
BOOL CWLClientApp::WaitOutReady(void)
{
	for( int i = 0; i < (WTIMEOUT/10); i++ ){
		if( !IsOutFull() ) return TRUE;
        ::Sleep(10);
        ProcessMessages();
		if( !IsConnected() ) return FALSE;
    }
    return FALSE;
}
//---------------------------------------------------------------------------
BOOL CWLClientApp::OutWrite(SHORT *buf)
{
	if( !IsConnected() ) return FALSE;

	if( m_OutOpen.size ){
		if( IsOutFull() && !WaitOutReady() ) return FALSE;
		if( SendServer(cmdOutWrite, buf, m_OutOpen.size*sizeof(SHORT)) ){
	        m_Counter.Remaining++;
    	    return TRUE;
        }
    }
	return FALSE;
}
//---------------------------------------------------------------------------
BOOL CWLClientApp::IsOutCritical(void)
{
	return m_Counter.Remaining <= (m_Counter.Max/2);
}
//---------------------------------------------------------------------------
BOOL CWLClientApp::IsOutFull(void)
{
	return m_Counter.Remaining >= m_Counter.Max;
}
//---------------------------------------------------------------------------
LONG CWLClientApp::GetOutRemaining(void)
{
	return m_Counter.Remaining;
}
//---------------------------------------------------------------------------
LONG CWLClientApp::GetOutCounter(void)
{
	return m_Counter.Counter;
}
//---------------------------------------------------------------------------
void CWLClientApp::SetOutCounter(LONG count)
{
	m_Counter.Counter = count;
    SendServer(cmdSetOutCounter, &m_Counter.Counter, sizeof(m_Counter.Counter));
}
/////////////////////////////////////////////////////////////////////////////
// EXPORT Functions
//---------------------------------------------------------------------------
extern "C" void __declspec(dllexport) __stdcall
mmwPumpMessages(void)
{
	theApp.ProcessMessages();
}
//---------------------------------------------------------------------------
extern "C" LONG __declspec(dllexport) __stdcall
mmwGetTimeout(void)
{
	return 60000;		// 60[s]
}
//---------------------------------------------------------------------------
extern "C" void __declspec(dllexport) __stdcall
mmwSetPTT(LONG tx)
{
	theApp.SetPTT(tx);
}
//---------------------------------------------------------------------------
extern "C" BOOL __declspec(dllexport) __stdcall
mmwInOpen(DWORD sampfreq, LONG size)
{
    return theApp.InOpen(sampfreq, size);
}
//---------------------------------------------------------------------------
extern "C" void __declspec(dllexport) __stdcall
mmwInClose(void)
{
	theApp.InClose();
}
//---------------------------------------------------------------------------
extern "C" BOOL __declspec(dllexport) __stdcall
mmwInRead(SHORT *buf)
{
	return theApp.InRead(buf);
}
//---------------------------------------------------------------------------
extern "C" LONG __declspec(dllexport) __stdcall
mmwGetInExist(void)
{
	return theApp.GetInExist();
}
//---------------------------------------------------------------------------
extern "C" BOOL __declspec(dllexport) __stdcall
mmwIsInCritical(void)
{
	return theApp.IsInCritical();
}
//---------------------------------------------------------------------------
extern "C" BOOL __declspec(dllexport) __stdcall
mmwOutOpen(DWORD sampfreq, DWORD size)
{
    return theApp.OutOpen(sampfreq, size);
}
//---------------------------------------------------------------------------
extern "C" void __declspec(dllexport) __stdcall
mmwOutAbort(void)
{
	theApp.OutAbort();
}
//---------------------------------------------------------------------------
extern "C" void __declspec(dllexport) __stdcall
mmwOutFlush(void)
{
	theApp.OutFlush();
}
//---------------------------------------------------------------------------
extern "C" BOOL __declspec(dllexport) __stdcall
mmwOutWrite(SHORT *buf)
{
	return theApp.OutWrite(buf);
}
//---------------------------------------------------------------------------
extern "C" BOOL __declspec(dllexport) __stdcall
mmwIsOutCritical(void)
{
	return theApp.IsOutCritical();
}
//---------------------------------------------------------------------------
extern "C" BOOL __declspec(dllexport) __stdcall
mmwIsOutFull(void)
{
	return theApp.IsOutFull();
}
//---------------------------------------------------------------------------
extern "C" LONG __declspec(dllexport) __stdcall
mmwGetOutRemaining(void)
{
	return theApp.GetOutRemaining();
}
//---------------------------------------------------------------------------
extern "C" LONG __declspec(dllexport) __stdcall
mmwGetOutCounter(void)
{
	return theApp.GetOutCounter();
}
//---------------------------------------------------------------------------
extern "C" void __declspec(dllexport) __stdcall
mmwSetOutCounter(LONG count)
{
	theApp.SetOutCounter(count);
}


