// WLDialog.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "WLClient.h"
#include "WLDialog.h"
#include "ColorStatic.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWLDialog _CAO


CWLDialog::CWLDialog(CWnd* pParent /*=NULL*/, CWLClientApp *pApp)
	: CDialog(CWLDialog::IDD, pParent)
{
	m_pApp = pApp;
	m_nTimerID = 0;
	m_Japanese = ((GetThreadLocale() & 0x00ff) == LANG_JAPANESE);
	//{{AFX_DATA_INIT(CWLDialog)
	m_AutoConnect = FALSE;
	m_ServerName = _T("");
	m_Monitor = FALSE;
	//}}AFX_DATA_INIT
}


void CWLDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWLDialog)
	DDX_Control(pDX, IDC_BPTT, m_DlgPTT);
	DDX_Control(pDX, IDC_BCONNECT, m_BConnect);
	DDX_Check(pDX, IDC_ACONNECT, m_AutoConnect);
	DDX_Text(pDX, IDC_EDITSERVER, m_ServerName);
	DDX_Check(pDX, IDC_MONITOR, m_Monitor);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_STATUS, m_Status);
}


BEGIN_MESSAGE_MAP(CWLDialog, CDialog)
	//{{AFX_MSG_MAP(CWLDialog)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BCONNECT, OnBconnect)
	ON_BN_CLICKED(IDC_ACONNECT, OnAconnect)
	ON_BN_CLICKED(IDC_MINIMIZE, OnMinimize)
	ON_EN_CHANGE(IDC_EDITSERVER, OnChangeEditserver)
	ON_BN_CLICKED(IDC_BPTT, OnBptt)
	ON_BN_CLICKED(IDC_MONITOR, OnMonitor)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
//---------------------------------------------------------------------------
BOOL CWLDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	if( m_Japanese ){
		CEdit *pEdit = (CEdit *)GetDlgItem(IDC_EDITSERVER);
		ASSERT(pEdit);

		LOGFONT	logfont;
		pEdit->GetFont()->GetLogFont(&logfont);
		logfont.lfCharSet = SHIFTJIS_CHARSET;
		m_pFont = new CFont;
		ASSERT(m_pFont);
		m_pFont->CreateFontIndirect(&logfont);
		pEdit->SetFont(m_pFont);
	}	
	m_DlgPTT.SetTextColor(RGB(255,0,0));
	m_nTimerID = SetTimer(1, WTIMERINTERVAL, NULL);
	return TRUE;
}
//---------------------------------------------------------------------------
BOOL CWLDialog::DestroyWindow() 
{
	if( m_nTimerID ){
		KillTimer(m_nTimerID);
		m_nTimerID = 0;
	}
	if( m_pFont ){
		m_pFont->DeleteObject();
		delete m_pFont;
		m_pFont = NULL;
	}
	return CDialog::DestroyWindow();
}
//---------------------------------------------------------------------------
void CWLDialog::UpdateStatus(LPCSTR pStatus, COLORREF col)
{
	m_Status.SetWindowText(pStatus, col);
}
//---------------------------------------------------------------------------
void CWLDialog::UpdateButton(BOOL enabled)
{
	m_BConnect.EnableWindow(enabled);
}
//---------------------------------------------------------------------------
void CWLDialog::GetServerName(CString &name)
{
	UpdateData(TRUE);
	name = m_ServerName;
}
//---------------------------------------------------------------------------
void CWLDialog::WindowControl(LPRECT pRect, int cmd)
{
	if( (pRect->left < -200) || (pRect->left > 2048) ) pRect->left = 0;
	if( (pRect->top < -100) || (pRect->left > 2048) ) pRect->top = 0;
	::SetWindowPos(m_hWnd, HWND_TOPMOST, pRect->left, pRect->top, 0, 0, SWP_NOSIZE);
	ShowWindow(cmd);
}
//---------------------------------------------------------------------------
BOOL CWLDialog::IsAutoConnect(void)
{
	return m_AutoConnect;
}
//---------------------------------------------------------------------------
void CWLDialog::OnTimer(UINT nIDEvent) 
{
	if( nIDEvent == m_nTimerID ){
		ASSERT(m_pApp);
		m_pApp->OnTimer();
	}
	CDialog::OnTimer(nIDEvent);
}
//---------------------------------------------------------------------------
void CWLDialog::OnBconnect() 
{
	ASSERT(m_pApp);
	m_pApp->ReqConnect();
}
//---------------------------------------------------------------------------
void CWLDialog::OnAconnect() 
{
	UpdateData(TRUE);
	ASSERT(m_pApp);
	m_pApp->PostThreadMessage(WM_SOCKETEVENT, MMSO_STATUS, 0);
}
//---------------------------------------------------------------------------
void CWLDialog::OnMinimize() 
{
	ShowWindow(SW_MINIMIZE);
}
//---------------------------------------------------------------------------
void CWLDialog::OnChangeEditserver() 
{
	ASSERT(m_pApp);
	m_pApp->ReqDisconnect();
}
//---------------------------------------------------------------------------
void CWLDialog::OnBptt() 
{
	m_pApp->SetSwPTT(m_DlgPTT.GetState());
}
//---------------------------------------------------------------------------
void CWLDialog::OnMonitor() 
{
	UpdateData(TRUE);
	ASSERT(m_pApp);
	m_pApp->OpenMonitor();
}
