#ifndef WAVE_H
#define WAVE_H
//---------------------------------------------------------------------------
#include <mmsystem.h>
//---------------------------------------------------------------------------
enum {
	MMWV_IN,
	MMWV_OUT,
};
#define WAVE_TIMEOUT_EVENT  2000		// obt@NGXg̃^CAEg
#define	WAVE_FIFO_MAX	    32			// zobt@̍ő
//---------------------------------------------------------------------------
class CWave
{
	friend void CALLBACK WaveInProc(HWAVE m_hin, UINT uMsg, CWave *pWave, DWORD dwParam1, DWORD dwParam2 );
	friend void CALLBACK WaveOutProc(HWAVE m_hout, UINT uMsg, CWave *pWave, DWORD dwParam1, DWORD dwParam2 );

public:
	CWinApp	*m_pApp;

	int     m_InFifoSize;
	int     m_OutFifoSize;
	int     m_SoundStereo;

	volatile int     m_InBC;
	volatile int     m_OutBC;
	volatile int     m_OutBCC;
private:
	LPWAVEHDR    m_pInBuff[WAVE_FIFO_MAX];	// ̓obt@
	LPWAVEHDR    m_pOutBuff[WAVE_FIFO_MAX];	// o̓obt@
	WAVEFORMATEX m_OWFX;		// o̓tH[}bg
	WAVEFORMATEX m_IWFX;		// ̓tH[}bg

	CRITICAL_SECTION m_InCS;
	CRITICAL_SECTION m_OutCS;

	HANDLE	m_InEvent;
	HANDLE	m_OutEvent;
	BOOL	m_InWait;
	BOOL	m_InOver;
	BOOL	m_OutWait;
	BOOL	m_OutUnder;

	int		m_InWP;
	int		m_InRP;

	int		m_OutWP;
	int		m_OutRP;

	int		m_Error;
	BOOL	m_InOpen;
	BOOL	m_OutOpen;

	LPSTR   m_pInBase;
	LPSTR   m_pOutBase;
	int		m_InLen;
	int		m_InBuffSize;
	int		m_InMemSize;
	int     m_InAllocSize;
	int		m_OutLen;
	int		m_OutBuffSize;
	int		m_OutMemSize;
	int     m_OutAllocSize;
	BOOL	m_OutFirst;
	HWAVEIN		m_hin;
	HWAVEOUT	m_hout;

public:
	CWave(void);
	~CWave();
//	BOOL __fastcall IsFormatSupported(LPWAVEFORMATEX pWFX, UINT IDDevice);
	BOOL __fastcall InOpen(LPWAVEFORMATEX pWFX, UINT IDDevice, DWORD Size);
	inline BOOL __fastcall IsInOpen(){return m_InOpen;};
	BOOL __fastcall InRead(SHORT *pData);
	void __fastcall InClose();
	BOOL __fastcall OutOpen(LPWAVEFORMATEX pWFX, UINT IDDevice, DWORD Size);
	inline BOOL __fastcall IsOutOpen(){return m_OutOpen;};
	BOOL __fastcall OutWrite(const SHORT *pData);
	void __fastcall OutFlush();
	void __fastcall OutAbort();
	void __fastcall OutClose(){OutFlush();OutAbort();};
//	DWORD __fastcall GetOutVolume(void);
//	BOOL __fastcall SetOutVolume(DWORD vol);
	inline int __fastcall IsInBufNull(void){return !m_InBC;};
	inline int __fastcall IsInBufCritical(void){
		return ( m_InBC >= (m_InFifoSize/2) ) ? 1 : 0;
	}
	inline int __fastcall IsOutBufCritical(void){
		return (m_OutBC <= (m_OutFifoSize/2)) ? 1 : 0;
	}
	inline int __fastcall IsOutBufFull(void){
		return (m_OutBC >= m_OutFifoSize) ? 1 : 0;
	};
};
//---------------------------------------------------------------------------
#endif

